Ext.define('DSS.component.MessageEditor', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : 140,
    txtReceiver : null,
    txtSubject : null,
    txtBody : null,
    padding : "0 0 0 10",
    constructor : function(config) {

        this.txtReceiver = Ext.create('Ext.form.field.Text', {
            fieldLabel : 'Empf&auml;nger',
            allowBlank : false,
            width : 750,
            labelWidth : 84,
            regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
            regexText : 'Die Emailadresse ist fehlerhaft',
            blankText : 'Die Emailadresse muss ausgef&uuml;llt werden',
            invalidText : 'Die Emailadresse muss ausgef&uuml;llt werden'
        });

        this.txtSubject = Ext.create('DSS.component.Textedit', {
            fieldLabel : 'Betreff',
            width : 750,
            labelWidth : 84,
            blankText : 'Betreff muss ausgef&uuml;llt werden',
            invalidText : 'Betreff muss ausgef&uuml;llt werden'
        });

        this.txtBody = Ext.create('DSS.component.TextAreaedit', {
            fieldLabel : 'Inhalt',
            width : 750,
            height : 60,
            labelWidth : 84,
            blankText : 'Inhalt muss ausgef&uuml;llt werden',
            invalidText : 'Inhalt muss ausgef&uuml;llt werden'
        });
        var oControlGroup = Ext.create('Ext.form.FieldSet', {
            title : config.title,
            width : "100%",
            items : [ this.txtReceiver, this.txtSubject, this.txtBody ]
        });

        Ext.apply(this, {
            items : [ this.txtReceiver, this.txtSubject, this.txtBody ]
        });
        this.callParent(arguments);
    },
    reset : function() {
        this.txtBody.reset();
        this.txtSubject.reset();
        this.txtReceiver.reset();
    },
    setValue : function(value) {
        // messageType:"email",
        this.txtBody.setValue(value.message);
        this.txtSubject.setValue(value.subject);
        this.txtReceiver.setValue(value.receiver);
    },
    isValid : function() {
        var fValid=false;
        this.txtSubject.markInvalid();
        this.txtBody.markInvalid();
        
        if (this.txtSubject.getValue()!=null)
            if (this.txtSubject.getValue().length>0)
                fValid=true;
        
        if (this.txtBody.getValue()!=null)
            if (this.txtBody.getValue().length>0)
                fValid=true;
        
        if (!fValid) {
            this.txtSubject.markInvalid('Entweder Betreff oder Inhalt m&uuml;ssen angegeben werden.');
            this.txtBody.markInvalid('Entweder Betreff oder Inhalt m&uuml;ssen angegeben werden.');
        }
        
        if (!this.txtReceiver.isValid()) {
            fValid=false;
        }
        return fValid;
    },
    getValue : function() {
        var oObject = {};
        oObject.messageType = 'email';
        oObject.receiver = this.txtReceiver.getValue();
        oObject.subject = this.txtSubject.getValue();
        if (oObject.subject==null)
            oObject.subject="";
        oObject.message = this.txtBody.getValue();
        if (oObject.message==null)
            oObject.message="";
        return oObject;
    }
});
